package com.example.criminalintent;

import java.util.Date;
import java.util.UUID;

import org.json.JSONException;
import org.json.JSONObject;

public class Crime
{
	private static final String JSON_ID = "id";
	private static final String JSON_TITLE = "title";
	private static final String JSON_SOLVED = "solved";
	private static final String JSON_DATE = "date";
	
	private UUID id;
	private String title;
	private Date date;
	private boolean isSolved;
	
	public Crime()
	{
		super();
		id = UUID.randomUUID();
		date = new Date();
	}

	public Crime(JSONObject json) throws JSONException
	{
	   id = UUID.fromString(json.getString(JSON_ID));
	   title = json.getString(JSON_TITLE);
	   isSolved = json.getBoolean(JSON_SOLVED);
	   date = new Date(json.getLong(JSON_DATE));
	}
	
	public String getTitle()
	{
		return title;
	}

	public void setTitle(String title)
	{
		this.title = title;
	}

	public UUID getId()
	{
		return id;
	}

	public Date getDate()
	{
		return date;
	}

	public void setDate(Date date)
	{
		this.date = date;
	}

	public boolean isSolved()
	{
		return isSolved;
	}

	public void setSolved(boolean isSolved)
	{
		this.isSolved = isSolved;
	}
	
	public JSONObject toJSON() throws JSONException
	{
	   JSONObject json = new JSONObject();
	   json.put(JSON_ID, id.toString());
	   json.put(JSON_TITLE, title);
	   json.put(JSON_SOLVED, isSolved);
	   json.put(JSON_DATE, date.getTime());
	   return json;
	}
}
