package com.example.criminalintent;

import java.util.ArrayList;
import java.util.UUID;

import android.content.Context;
import android.util.Log;

public class CrimeLab
{
	private static final String FILE = "crimes.txt";
	
	private static CrimeLab crimeLab;
	private Context context;
	private ArrayList<Crime> crimes;
	private JSONSerializer serializer;
	
	private CrimeLab(Context context)
	{
		super();
		this.context = context;
		this.crimes = new ArrayList<Crime>();
		this.serializer = new JSONSerializer(context, FILE);
	   crimes = new ArrayList<Crime>(); 
	   try 
	   { 
	      crimes = serializer.loadCrimes(); 
/*
	      Crime crime = new Crime();

	      crime.setTitle("Crime 1");
	      crimes.add(crime);
	      crime = new Crime();
	      crime.setTitle("Crime 2");
	      crimes.add(crime);
	      crime = new Crime();
	      crime.setTitle("Crime 3");
	      crimes.add(crime);
*/
	     } 
	   catch (Exception e) 
	   { 
	      crimes = new ArrayList<Crime>(); 
	      Log.e("Crime", "Error loading crimes: ", e); 
	   }
	}
	
	public static CrimeLab get(Context context)
	{
		if (crimeLab == null)
			crimeLab = new CrimeLab(context);
		return crimeLab;
	}
	
	public ArrayList<Crime> getCrimes()
	{
		return crimes;
	}
	
	public Crime getCrime(UUID id)
	{
		for (Crime crime: crimes)
		{
			if (crime.getId().equals(id))
				return crime;
		}
		return null;
	}
	
	public void save()
	{
	   try
	   {
	      serializer.saveCrimes(crimes);
	      Log.d("Crime", "File saved successfully");
	   }
	   catch(Exception ex)
	   {
	      Log.e("Crime", "Error saving file", ex);
	   }
	}
}
